package com.awesome.flulm_auth.handler;

import android.text.TextUtils;

import com.awesome.flulm_auth.constant.LmPluginKeys;
import com.awesomeglobal.paysdk.openapi.LMAPIFactory;
import com.awesomeglobal.paysdk.openapi.LMAuth;

import java.util.HashMap;
import java.util.Map;

import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.PluginRegistry;

public class LmAPiHandler {
    private static PluginRegistry.Registrar registrar;
    public static LMAuth lmAuth;


    public static void setRegistrar(PluginRegistry.Registrar registrar1) {
        registrar = registrar1;
    }


    public static void registerApp(MethodCall call, MethodChannel.Result result) {

        if (!(Boolean) call.argument(LmPluginKeys.ANDROID)) {
            return;
        }

        if (lmAuth != null) {
            Map<String, Object> map = new HashMap<>();
            map.put(LmPluginKeys.PLATFORM, LmPluginKeys.ANDROID);
            map.put(LmPluginKeys.RESULT, true);
            result.success(map);
            return;
        }

        String appId = call.argument(LmPluginKeys.APP_ID);
        if (TextUtils.isEmpty(appId)) {
            result.error("invalid app id", "are you sure your app id is correct ?", appId);
            return;
        }
        if (registrar == null) {
            return;
        }


        lmAuth = LMAPIFactory.createLMAPI(registrar.context().getApplicationContext(), appId);
        boolean registered = lmAuth.registerApp(appId);
        Map<String, Object> map1 = new HashMap<>();
        map1.put(LmPluginKeys.PLATFORM, LmPluginKeys.ANDROID);
        map1.put(LmPluginKeys.RESULT, registered);
        result.success(map1);
    }

    public static void checkInstallation(MethodChannel.Result result) {
        if (lmAuth == null) {
            result.error("lmapi not configured", "please config  lmapi first", null);
        } else {
            result.success(lmAuth.isLMAppInstalled());
        }
    }

    public static void getSupportAPI(MethodChannel.Result result) {
        if (lmAuth == null) {
            result.error("lmapi not configured", "please config  lmapi first", null);
            return;
        } else {
            result.success(lmAuth.getLMAppSupportAPI());
        }
    }
}
