//
//  FluwxAuthHandler.m
//  flulm_auth
//
//  Created by SHU on 6/20/20.
//

#import "FluwxAuthHandler.h"

@implementation FluwxAuthHandler

FlutterMethodChannel *_fluwxMethodChannel = nil;

- (instancetype)initWithRegistrar:(NSObject <FlutterPluginRegistrar> *)registrar methodChannel:(FlutterMethodChannel *)flutterMethodChannel {
    self = [super init];
    if (self) {
        NSLog(@"init flutterMethodChannel====");
        _fluwxMethodChannel = flutterMethodChannel;
    }

    return self;
}

- (void)handleAuth:(FlutterMethodCall *)call result:(FlutterResult)result {

    printf("LemaAPI sendOAuthRequest====");
     [LemaAPI sendOAuthRequest];
}

-(void)handelUrl:(NSURL *)url{
    NSLog(@"拿到回调==%@", url);
    NSString * urlString = url.absoluteString;
           if([urlString containsString:@"code"] == YES){
               NSError *error;
               NSString *code = nil;
               NSString *regTags=[[NSString alloc] initWithFormat:@"(^|&|\\?)+%@=+([^&]*)(&|$)", @"code"];
               NSRegularExpression *regex = [NSRegularExpression regularExpressionWithPattern:regTags
                                                                                      options:NSRegularExpressionCaseInsensitive
                                                                                        error:&error];
               // 执行匹配的过程
               NSArray *matches = [regex matchesInString:urlString options:0 range:NSMakeRange(0, urlString.length)];
               for (NSTextCheckingResult *match in matches) {
                   code = [urlString substringWithRange:[match rangeAtIndex:2]];
                   break;
               }
               if(code != nil){
                   NSLog(@"解析的code = %@", code);
                   NSDictionary *dic = @{@"code" : code, @"errCode": @(0), @"errStr": @"获取成功"};
                   [_fluwxMethodChannel invokeMethod:@"onAuthResponse" arguments:dic];
               }else{
                   NSDictionary *dic = @{@"code" : @"", @"errCode": @(-1), @"errStr": @"获取失败"};
                   [_fluwxMethodChannel invokeMethod:@"onAuthResponse" arguments:dic];
               }
           }else{
               NSDictionary *dic = @{@"code" : @"", @"errCode": @(-1), @"errStr": @"用户取消"};
                              [_fluwxMethodChannel invokeMethod:@"onAuthResponse" arguments:dic];
           }
}



- (void)onTokenResponse:(LemaAccessInfo *)info { 

}

- (void)onTokenResponseError:(NSString *)msg { 
    
}

- (void)onUserInfoResponse:(LemaUserInfo *)userInfo { 
    
}

- (void)onUserInfoResponseError:(NSString *)msg { 
    
}

@end

